//Przykladowa implementacja drzew BST
//Implementacja zawiera rekurencyjna wersje usuwania elementu 
//z drzewa bst, bo taka jest krotsza.
//Implementacja nie zawiera referencji (poza operatorami cout), 
//aby ograniczyc wykorzystanie obiektowych narzedzi jezyka.

//Przykladowe cwiczenia:
//-policz ilosc wezlow w drzewie, sume kluczy, sume kluczy w lisciach,
// wysokosc drzewa, ilosc elementow, ktore nie sa liscmi,
// podloge w drzewie dla wartosci k, 
// range k (ilosc elementow w drzewie o wartosciach <=k,
// szerokosc drzewa (najwieksza licznosc poziomu).
// zamiana drzewa bst na liste uporzadkowana.

#include<cstdio>
#include<cstdlib>
#include<iostream>
#include<iomanip>
#include<limits>


using namespace std;

//maksymalne i minimalne wartosci int
int imin = numeric_limits<int>::min(); 
int imax = numeric_limits<int>::max();

typedef struct Node{
int key;
Node *left, *right;
}Node;


//Oczekiwanie na [Enter];
//Odkomentuj wlasciwa linie
void pressenter(){
system("read -p \"Press [Enter]\" "); //Linux
//system("pause"); //DOS
}

ostream& operator<<(ostream& os, Node * t){
   if(t!=NULL){
     os<<"("<<t->key<<") -> ";
     if(t->left==NULL)
      os<<"(null)";
   else
     os<<"("<<(t->left)->key<<"), ";
  if(t->right==NULL)
      os<<"(null)";
   else
     os<<"("<<(t->right)->key<<")";
 }
  return os;
}

void print(Node* t){
	if(t!=NULL){
      cout<<t<<endl;
      print(t->left);
      print(t->right);
	}
}

Node* root=NULL;

//rotacje
void rotR(Node ** t){
	Node *tmp=(*t);
	(*t)=(*t)->left;
	tmp->left=(*t)->right;
	(*t)->right=tmp;
}

void rotL(Node ** t){
	Node *tmp=(*t);
	(*t)=(*t)->right;
	tmp->right=(*t)->left;
	(*t)->left=tmp;
}


//Wstawianie do drzewa.
//Moga Pasntwo napisac:
//wstawianie z rekusja (bez petli).
int insert(int k){
	Node *prev=NULL;
	Node *r=root;
	while(r!=NULL){
		prev=r;
		if(r->key==k)
			return 0;
		else{
			if(r->key<k)
				r=r->right;
			else
				r=r->left;
		}
	}
	if(prev==NULL){
		root=new(Node);
		root->key=k;
		root->left=root->right=NULL;
		return 0;
	}
	if(prev->key<k){
		prev->right=new(Node);
		(prev->right)->key=k;
		(prev->right)->left=(prev->right)->right=NULL;
		return 0;
	}
	else{
		prev->left=new(Node);
		(prev->left)->key=k;
		(prev->left)->left=(prev->left)->right=NULL;
		return 0;
	}
 //print(root); pressenter();
 return 0;
}

//wstawianie do korzenia drzewa
//jako cwiczenia moga Panstwo 
//przetlumaczyc te funkcje na funkcje 
//przyjmujaca referencje _insert_to_root2(Node *& t,int k)
void _insert_to_root(Node ** t,int k){
	if((*t)==NULL){
		(*t)=new(Node);
		(*t)->key=k;
		(*t)->left=(*t)->right=NULL;
		return;
	}
	if((*t)->key==k){
		return;
	}
	if((*t)->key<k){
		_insert_to_root(&((*t)->right),k);
		rotL(t);
		return;
	}
	_insert_to_root(&((*t)->left),k);
	rotR(t);
}

void insert_to_root(int k){
	_insert_to_root(&root,k);
}


Node * find(int k){
	//To prosze uzupelnic
	
}


//Usuwanie elementu z drzewa.
//Moga Panstwo napisac:
// - usuwanie z wykorzystaniem referencji zamiast podwojnych wskaznikow
// - usuwanie bez referencji, bez wskaznikow do wskaznikow i bez rekursji (sporo pisania)

void _delete_key(Node ** r, int k){
	if((*r)==NULL)
		return;
	if((*r)->key<k)
		_delete_key(&((*r)->right),k);
	if((*r)->key>k)
		_delete_key(&((*r)->left),k);
	//teraz: *r!=NULL && (*r)->key==k
	if((*r)->left==NULL){
		Node *tmp=(*r)->right;
		delete(*r);
		*r=tmp;
		return;
	}
	if((*r)->right==NULL){
		Node *tmp=(*r)->left;
		delete(*r);
		*r=tmp;
		return;
	}
	Node **tmp=&((*r)->left);
	while((*tmp)->right!=NULL)
		tmp=&((*tmp)->right);
	(*r)->key=(*tmp)->key;
	_delete_key(tmp,(*tmp)->key);
}

void delete_key(int k){
	_delete_key(&root,k);
}
	
//usuwanie drzewa - postorder 
void cleaning(Node* t){
   if(t==NULL)
     return;
   cleaning(t->left);
   cleaning(t->right);
   delete(t);
}

//_isbst zwraca 1, jesli drzewo jest bst, 0 wpp
int _isbst(Node *t, int left, int right){
	if(t==NULL)
		return 1;
	if(left<t->key && t->key <right){
		return _isbst(t->left,left,t->key) && _isbst(t->right,t->key,right);
	}
	return 0;
}

//czy drzewo jest bst
int isbst(Node *t){
	return _isbst(t, imin, imax);
}
 
int bst_test(){
	for(int i=0;i<100;i++){
		int k=rand()%30;
		insert(k);
		int m=rand()%30;
		delete_key(m);
		if(!isbst(root)){
			cleaning(root);
			return 0;
		}
	}
	cleaning(root);
	return 1;
}	
 

const int N=8;
int main(){
	srand(time(NULL));
	for(int i=0;i<100;i++)
		if(bst_test()==0){
			cout<<endl<<"Nieprawidlowy wynik testow"<<endl;
			pressenter();
			return 0;
		}
	int tab[N]={3,5,1,6,4,2,9,0};
	for(int i=0;i<N;i++)
		insert_to_root(tab[i]);
	cout<<endl<<"Drzewo "<<(isbst(root)?"":"nie")<<" jest drzewem bst"<<endl;
	print(root);
	cleaning(root);
	pressenter();
	return 0;
}